import React from "react";
import { map, startWith } from "rxjs";
import { useObservableSubscribe } from "../../..";
export const ControlErrors = props => {
  const {
    value
  } = useObservableSubscribe({
    obs$: props.control.statusChanges.pipe(startWith(props.control.status), map(statusType => {
      if (statusType === 'INVALID') {
        // INVALID, PENDING, DISABLED,  VALID
        return {
          status: 'ERROR',
          error: props.control.errors
        };
      } else if (statusType === 'PENDING') {
        return {
          status: 'PROCESSING',
          data: {}
        };
      }

      return {
        status: 'SUCCESS',
        data: {}
      };
    }))
  });
  const renderErrors = props.renderErrors;
  const errorTemplate = value.status === 'ERROR' && renderErrors && renderErrors({
    errors: value.error,
    control: props.control
  });
  const renderProcessing = props.renderProcessing;
  const processingTemplate = value.status === 'PROCESSING' && renderProcessing && renderProcessing();
  return /*#__PURE__*/React.createElement(React.Fragment, null, errorTemplate, processingTemplate);
};